mysite/myauth/urls.py
from django.urls import path
from .views import (login_view, get_cookie_view, set_cookie_view, get_session_view, set_session_view, \
    logout_view, MyLogoutView, AboutMeView, RegisterView, FooBarView, ProfileUpdate, UserListView, UserDetail,
                    UpdateView, UserUpdate, HelloView)
from django.contrib.auth.views import LoginView

app_name='myauth'

urlpatterns=[
    #path('login/', login_view, name='login')
    path('login/',
         LoginView.as_view(template_name='myauth/login.html', redirect_authenticated_user=True),
         name='login'),
    # path('logout/', logout_view, name='logout'),
    path('logout/', MyLogoutView.as_view(), name='logout'),
    path('cookie/get', get_cookie_view, name='cookie-get'),
    path('cookie/set', set_cookie_view, name='cookie-set'),
    path('session/get', get_session_view, name='session-get'),
    path('session/set', set_session_view, name='session-set'),
    path('about-me/', AboutMeView.as_view(), name='about-me'),
    path('register/', RegisterView.as_view(), name='register'),
    path('foo-bar', FooBarView.as_view(), name='foo-bar'),
    path('users/', UserListView.as_view(), name='users'),
    path('users/<int:pk>', UserDetail.as_view(), name='users_detail'),
    path('users/<int:pk>/change', UserUpdate.as_view(), name='change_profile'),
    path('hello/', HelloView.as_view(), name='hello')
]

mysite/mysite/urls.py
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin
from django.contrib.sitemaps.views import sitemap
from django.urls import path, include
from django.conf import settings

from drf_spectacular.views import SpectacularAPIView, SpectacularRedocView, SpectacularSwaggerView

from .sitemaps import sitemaps

urlpatterns = [
    path('admin/doc/', include('django.contrib.admindocs.urls')),
    path('admin/', admin.site.urls),
    path('requestdataapp/', include('requestdataapp.urls')),
    path('api/schema/', SpectacularAPIView.as_view(),name='schema'),
    path('api/schema/swagger/', SpectacularSwaggerView.as_view(url_name='schema'),name='swagger'),
    path('api/schema/redoc/', SpectacularRedocView.as_view(url_name='schema'),name='redoc'),
    path('api/', include('myapiapp.urls')),
    path('blogapp/', include('blogapp.urls')),
    path('news/', include('newsapp.urls')),
    path('sitemap.xml', sitemap, {'sitemaps': sitemaps}, name='sitemap')
]

urlpatterns+=i18n_patterns(
    path('myauth/', include('myauth.urls')),
    path('shopapp/', include('shopapp.urls')),

)

if settings.DEBUG:
    urlpatterns.extend(
        static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    )
    urlpatterns.extend(
        static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    )
    urlpatterns.append(path('__debug__/' ,include('debug_toolbar.urls')))

mysite/myauth/models.py
from django.contrib.auth.models import User
from django.db import models

# Create your models here.

def user_images_directory_path(instanse: "Profile", filename: str) -> str:
    return f'users/user_{instanse.user.pk}/images/{filename}'


class Profile(models.Model):
    user=models.OneToOneField(User, on_delete=models.CASCADE)
    bio=models.TextField(max_length=500, blank=True)
    agreement_accepted=models.BooleanField(default=False)
    avatar = models.ImageField(null=True, blank=True, upload_to=user_images_directory_path)

mysite/myauth/forms.py
from django import forms

from .models import Profile


class ProfileForms(forms.ModelForm):
    class Meta:
        model = Profile
        fields= 'avatar', 'bio'

mysite/myauth/views.py
from random import random

from django.contrib.auth.decorators import login_required, permission_required, user_passes_test
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.contrib.auth.views import LogoutView
from django.http import HttpRequest, HttpResponse, JsonResponse
from django.shortcuts import render, redirect
from django.contrib.auth import authenticate, login, logout
from django.urls import reverse, reverse_lazy
from django.utils.translation import gettext_lazy, ngettext
from django.views import View
from django.views.decorators.cache import cache_page
from django.views.generic import TemplateView, CreateView, UpdateView, DetailView, ListView

from .models import Profile
from .forms import ProfileForms



def login_view(request: HttpRequest):
    if request.method=='GET':
        if request.user.is_authenticated:
            return redirect('/admin/')
        return render(request, 'myauth/login.html')
    username=request.POST['username']
    password = request.POST['password']

    user=authenticate(request, username=username, password=password)
    print(user)
    if user is not None:
        login(request, user)
        return redirect('/admin/')
    return render(request, 'myauth/login.html', {'error': 'Incorrect data'})

def logout_view(request:HttpRequest):
    logout(request)
    return redirect(reverse('myauth:login'))

class MyLogoutView(LogoutView):
    next_page = reverse_lazy('myauth:login')

@user_passes_test(lambda u: u.is_superuser)
def set_cookie_view(request: HttpRequest):
    response=HttpResponse('Cookie set')
    response.set_cookie('fizz', 'buzz', max_age=3600)
    return response

@cache_page(120)
def get_cookie_view(request: HttpRequest):
    value=request.COOKIES.get('fizz', 'default value')
    return HttpResponse(f'Cookie value: {value}+{random()}')




@permission_required('myauth.view_profile', raise_exception=True)
def set_session_view(request: HttpRequest):
    request.session['a']='b'
    return HttpResponse('Session set')

@login_required
def get_session_view(request: HttpRequest):
    value=request.session.get('a', 'default value')
    return HttpResponse(f'Session value: {value}')

class AboutMeView(UpdateView):
    template_name = "myauth/about-me.html"
    model = Profile
    fields = "avatar",'bio'

    success_url = reverse_lazy("myauth:about-me")

    # def form_valid(self, form):
    #     response = super().form_valid(form)
    #     for image in form.files.getlist('images'):
    #         Profile.objects.create(
    #             product=self.object,
    #             image=image
    #         )
    #     return response

    def get_object(self, queryset=None):
        return self.request.user.profile



class RegisterView(CreateView):
    form_class = UserCreationForm
    template_name = 'myauth/register.html'
    success_url = reverse_lazy('myauth:about-me')

    def form_valid(self, form):
        response=super().form_valid(form)
        Profile.objects.create(user=self.object)
        user=authenticate(self.request,username=form.cleaned_data.get('username'),
                          password=form.cleaned_data.get('password1'))
        login(request=self.request,user=user)

        return response

class FooBarView(View):
    def get(self, request: HttpRequest):
        return JsonResponse({'foo': 'bar', 'spam':'eggs'})




class ProfileUpdate(UpdateView):

    model = Profile
    # fields = 'name', 'price', 'description', 'discount', 'preview'
    form_class = ProfileForms
    template_name_suffix = '_update_form'

    def get_object(self, queryset=None):
        return self.request.user.profile

# def get_users(request:HttpRequest):
#     users=Profile.objects.all()
#     return render(request,'myauth/users.html', context={'users': users})

class UserListView(ListView):
    template_name = 'myauth/users.html'
    model=Profile
    context_object_name = 'users'

class UserDetail(DetailView):
    template_name = 'myauth/user-detail.html'
    model = Profile
    context_object_name = 'users'

class UserUpdate(UpdateView):
    def test_func(self):
        return self.request.user.is_superuser

    model = Profile
    form_class = ProfileForms
    template_name = 'myauth/profile_change.html'

    def get_object(self, queryset=None):
        pk = self.kwargs.get(self.pk_url_kwarg)
        print(pk)
        user = Profile.objects.get(pk=pk)
        print(user.user.username)
        return user


class HelloView(View):
    welcome_messge = gettext_lazy('Hello world')
    def get(self, request: HttpRequest):
        items_str=request.GET.get('items') or 0
        items=int(items_str)
        products_line=ngettext(
            'one product',
            '{count} products',
            items
        )
        products_line=products_line.format(count=items)
        return HttpResponse(f'<h1>{self.welcome_messge}</h1>\n<h2>{products_line}</h2>')

mysite/myauth/templates/myauth/about-me.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>About me</title>
</head>
<body>
{% load cache %}
<h1>User info</h1>
{% if user.is_authenticated %}

<h2>Details:</h2>
<form method="post" enctype="multipart/form-data">
    {%csrf_token%}
    {% if  form.avatar%}

    {%else%}
    <p>No avatar</p>
    {%endif%}
    <p>Change avatar: {{form.avatar}}</p>
    <p>Username: {{user.username}}</p>
    <p>Firstname: {{user.first_name}}</p>
    <p>Lastname: {{user.last_name}}</p>
    <p>Email: {{user.email}}</p>
    <p>Bio: {{form.bio}}</p>

    {%else%}
    <h2>User not authenticated</h2>
    {%endif%}
    <button type="submit">Update</button>
</form>
<div>



</div>
</body>
</html>

mysite/myauth/templates/myauth/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>
      {%block title%}
      {%endblock%}
    </title>
</head>
<body>
{%block body%}
{%endblock%}
</body>
</html>

mysite/myauth/templates/myauth/login.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Login</title>
</head>
<body>
<form method="post">
  {%csrf_token%}
<!--  {%if error%}-->
<!--  <p style="color: red">{{error}}</p>-->
<!--  {%endif%}-->
<!--  <div>-->
<!--    <label for="username">Username: </label>-->
<!--  <input type="text" id="username" name="username" required>-->
<!--  </div>-->
<!--  <div>-->
<!--    <label for="password">Password: </label>-->
<!--  <input type="password" id="password" name="password" required>-->
<!--  </div>-->
  {{form.as_p}}
  <button type="submit">Login</button>
</form>
</body>
</html>

mysite/myauth/templates/myauth/profile_change.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Change profile</title>
</head>
<body>
<form method="post" enctype="multipart/form-data">
    {%csrf_token%}
    {{form.as_p}}
    <input type="submit" value="Change">
</form>
<a href="{%url 'myauth:users_detail' pk=user.pk%}">Back</a>
</body>
</html>

mysite/myauth/templates/myauth/profile_update_form.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Update info</title>
</head>
<body>
    <form method="post" enctype="multipart/form-data">
        {%csrf_token%}
        {{form.as_p}}
        <button type="submit">Update</button>
    </form>
</body>
</html>

mysite/myauth/templates/myauth/register.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Register</title>
</head>
<body>
<h1>Register</h1>
<form method="post">
    {%csrf_token%}
    {{form.as_p}}
    <input type="submit" value="Register">
</form>
</body>
</html>

mysite/myauth/templates/myauth/user-detail.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>User Detail</title>
</head>
<body>
<div>
    <div>
        <p>Avatar: </p>
        {%if users.avatar%}
        <img src="{{users.avatar.url}}" alt="avatar" width="100" height="100">
        {%else%}
        <p>No avatar</p>
        {%endif%}
    </div>
    <p>Name: {{users.user.username}}</p>
    <p>Firstname: {{users.user.first_name}}</p>
    <p>Lastname: {{users.user.last_name}}</p>
    <p>Email: {{users.user.email}}</p>
    <p>Bio: {{users.bio}}</p>
</div>
<a href="{% url 'myauth:users' %}">Back</a>
{%if user.is_superuser%}
<br>
<a href="{% url 'myauth:change_profile' pk=user.pk%}">Change profile</a>
{%endif%}
</body>
</html>

mysite/myauth/templates/myauth/users.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Users</title>
</head>
<body>
{% for user in users %}
<p><a href="{% url 'myauth:users_detail' pk=user.pk%}">{{user.user.username}}</a></p>
{%endfor%}

</body>
</html>